#include <list>
#include <iostream>
using namespace std;

template<class T>
const T& min(const T& a, const T& b) {
	if (a < b)
		return a;
	else
		return b;
}

template<class T>
T& min_element(T f[], int n) {
	int m = 0;
	for (int i = 1; i<n; i++)
	if (f[i] < f[m])
		m = i;
	return f[m];
}

template<class T>
void byt(T& a, T& b) {
	T temp = a; a = b; b = temp;
}

template<class T>
void sort(T f[], int n) {
	for (int k = 0; k<n; k++)
		byt(f[k], min_element(f + k, n - k));
}

// Typparametern IT nedan r en iterator el. pekartyp
template<class IT>
IT min_element(IT first, IT last) {
	IT m = first;
	for (IT i = ++first; i != last; i++)
	if (*i < *m)
		m = i;
	return m;
}

template<class IT>
void sort(IT first, IT last) {
	for (IT k = first; k != last; k++)
		byt(*k, *min_element(k, last));
}

// Compare r en egenskapsklass av funktionsobjektstyp
template<class IT, class Compare>
IT min_element(IT first, IT last, Compare cmp) {
	IT m = first;
	for (IT i = ++first; i != last; i++)
	if (cmp(*i, *m))
		m = i;
	return m;
}
// Egenskapsklassen mste ha funktionsdefinitionsop.:
class Str_Less_Than {
public:
	bool operator () (char *s1, char *s2)
	{
		return strcmp(s1, s2) < 0;
	}
};

template<class IT>
void skriv(IT first, IT last) {
	for (IT k = first; k != last; k++)
		cout << *k << ' ';
	cout << endl;
}


int main() {
	double x = 7.0, y = 5.0;
	long m = 5, n = 7;
	//...
	cout << min(x, y) << endl;
	cout << min(m, n) << endl;
	// Blandat funkar inte (ingen casting grs!)
//	cout << min(m, y) << endl;
	// Fr att forcera casting blir man explicit
	cout << min<double>(m, y) << endl;

	double a[11] = { 11, 7, 3, 4, 9, 16, 13, 12, 19, 17, 21 };
	list<int> l = { 11, 7, 3, 4, 9, 16, 13, 12, 19, 17, 21 };
	//...
	cout << *min_element(a, a + 11) << endl;
	cout << *min_element(l.begin(), l.end()) << endl;
	sort(a, a + 11);
	skriv(a, a + 11);
	sort(l.begin(), l.end());
	skriv(l.begin(), l.end());

	//
	list<char *> tl = { "hej", "du", "glade", "med", "hink", "och", "spade" };
	Str_Less_Than lt; // funktionsobjekt
	// ...
	cout << *min_element(tl.begin(), tl.end(), lt);
	// Annan variant av ovanstende anrop:
	cout << *min_element(tl.begin(), tl.end(), Str_Less_Than());
	// Hr skapas automatiskt ett objekt av typ Str_Less_Than

	cin >> ws;
}
